Unit GDinar;   (*numero aleatorio de distribucion multivariante*)

INTERFACE
Uses FUNG, Forms, Dialogs;
{NUCLEO abstraction}

TYPE  _IndiceV  = array[1..1] of integer;
      _Indice   = ^_IndiceV;
       RealV    = array[1..1] of real;
       Memo     = ^RealV;
      _Arreglo = Record
                  Base : Memo;
                  nDim : byte;
                  Rango: _Indice;
                 End;

PROCEDURE _HazIndice(nDim: byte; Var IX: _Indice);
PROCEDURE _DestruIndice(nDim: byte; Var IX: _Indice);
PROCEDURE _Definir(Var X: _Arreglo; Direc: Memo; nD: integer; Dims: _Indice);
PROCEDURE _DistriConj(Var A: _Arreglo);
PROCEDURE _SeleDistriConj(Var A: _Arreglo; semilla: integer; Dims: _Indice);

IMPLEMENTATION

Procedure _HazIndice(nDim: byte; Var IX: _Indice);
Begin   GetMem(IX, nDim * SizeOf(integer));   End;

Procedure _DestruIndice(nDim: byte; Var IX: _Indice);
Begin   FreeMem(IX, nDim * SizeOf(integer));  End;

FUNCTION Dir(Var X: _Arreglo; I: _Indice): integer;
Var Desplaz, j: integer;
Begin
  With X do Begin
    Desplaz:=I^[1] - 1;
    For j:=2 to nDim do Desplaz:=Desplaz*Rango^[j] + I^[j] - 1;
    Dir:=Desplaz;
  End; {With}
End; {Dir}

FUNCTION v(Var X: _Arreglo; I: _Indice): real;
Begin    v:=X.Base^[1+Dir(X,I)]        End;

PROCEDURE g(Var X: _Arreglo; I: _Indice; valor: real);
Begin    X.Base^[1+Dir(X,I)]:=valor    End;

PROCEDURE _Definir(Var X: _Arreglo; Direc: Memo; nD: integer; Dims: _Indice);
Var j: integer; Tama: integer;
Begin
  With X do Begin
       Tama:=1;
       nDim:=nD;
       GetMem(Rango, nDim * SizeOf(integer));
       For j:=1 to nDim do Begin
         Rango^[j]:=Dims^[j];
         Tama:=Tama * Dims^[j];
       End;
       If Direc=nil then
       Begin
         GetMem(Base, Tama * SizeOf(Real));
         If Base = nil then
            Begin  MessageDlg('Out of Memory',mtError,[mbOK],0);
                   Application.Terminate; End;
       End
       else Base:=Direc;
  End; {With}
End; {Definir}

PROCEDURE ProxOrden(Var X: _Arreglo; IX, Orden: _Indice; Tope: integer;
                    Var Completo: boolean);
{Tope es el numero de posiciones de indice que hay en Orden;
 en Orden se colocan los indices de izquierda a derecha, el mas lento
 el mas a la izquierda}
Var SeIncremento: boolean;  i: integer;
Begin
  SeIncremento:=false;
  With X do Begin
     i:=Tope;
     While not SeIncremento do Begin
       If (IX^[Orden^[i]] = Rango^[Orden^[i]]) then
          If i > 1 then Begin IX^[Orden^[i]]:=1; Dec(i); End
                      else Begin SeIncremento:=true; Completo:=true; End
                                         else
          Begin IX^[Orden^[i]]:=IX^[Orden^[i]] + 1; SeIncremento:=true; End;
     End; {While}
  End; {With}
End; {ProxOrden}

PROCEDURE _DistriConj(Var A: _Arreglo);
VAR  i, j: integer;
     Completo, Completo2: boolean;
     IX, Orden, Orden2: _Indice;
     s: real;
Begin
 {Distribucion Conjunta en A }
  _HazIndice(A.nDim,IX);
  _HazIndice(A.nDim,Orden);
  _HazIndice(A.nDim,Orden2);
  With A do Begin
     For j:=nDim downto 1 do Begin
       For i:=1 to j-1 do Begin IX^[i]:=1;
                                Orden^[i]:= i;
                          End;
       Orden2^[1]:=j;
       For i:=j+1 to nDim do IX^[i]:=Rango^[i];
       Completo:=false;
       Repeat
         s:=0;
         Completo2:=false;
         IX^[j]:=1;
         Repeat  s:=s+v(A,IX);   g(A,IX,s);
            ProxOrden(A,IX,Orden2,1,Completo2);
         Until Completo2;
         Completo2:=false;
         IX^[j]:=1;
         Repeat  g(A,IX,v(A,IX)/s);
            ProxOrden(A,IX,Orden2,1,Completo2);
         Until Completo2;
         g(A,IX,s);
         If j>1 then ProxOrden(A,IX,Orden,j-1,Completo)
                else Completo:=true;
       Until Completo;
     End;
  End;
  _DestruIndice(A.nDim,IX);
  _DestruIndice(A.nDim,Orden);
  _DestruIndice(A.nDim,Orden2);
 End; {DistriConj}

PROCEDURE _SeleDistriConj(Var A: _Arreglo; semilla: integer; Dims: _Indice);
VAR    i, j: integer;
       Completo: boolean;
       IX, Orden: _Indice;
       p, vA: real;
Begin
  _HazIndice(A.nDim,IX);
  _HazIndice(A.nDim,Orden);
  With A do Begin
    For i:=1 to nDim do IX^[i]:=Rango^[i];
    For j:=1 to nDim do Begin
      Orden^[1]:=j;     IX^[j]:=1;
      Completo:=false;
      p:=rnd(semilla);
      Repeat
        If   IX^[j] < Rango^[j] then
             Begin vA:=v(A,IX);
               If   p<=vA then Begin Completo:=true;
                                 Dims^[j]:=IX^[j];
                               End
               else ProxOrden(A,IX,Orden,1,Completo);
             End
        else Begin Completo:=true;
               Dims^[j]:=IX^[j];
             End;
      Until Completo;
    End;
  End;
  _DestruIndice(A.nDim,IX);
  _DestruIndice(A.nDim,Orden);
End; {SeleDistriConj}

END.
