unit UGLMemo;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Menus, uPresen, uPresen2,Tipos, Printers {Delphi 3.6.2001};

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    SaveAs1: TMenuItem;
    Print1: TMenuItem;
    Close1: TMenuItem;
    SaveDialog1: TSaveDialog;
    PrintDialog1: TPrintDialog;
    Memo1: TMemo;

    procedure SaveAsClick(Sender: TObject);
    procedure PrintDialog1Click(Sender: TObject);
    procedure Cerrar(Sender: TObject);
    function  CloseQuery: boolean; override;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);

  private
    { Private declarations }
    NombreArchivo: string;
    Cerrada, Abierta: boolean;
  public
    { Public declarations }
  end;

var
  Form1, Form2, Form3: TForm1;
procedure InitMemos; export;
procedure VerArchivoSalida(var NomArchivo: string); export;
procedure VerArchivoTrazado(var NomArchivo: string); export;
procedure VerArchivoReporte(var NomArchivo: string); export;

implementation

{$R *.DFM}

procedure TForm1.SaveAsClick(Sender: TObject);
begin
  if SaveDialog1.Execute then
  begin
    NombreArchivo:=SaveDialog1.FileName;
    Memo1.Lines.SaveToFile(NombreArchivo);
  end;
end;

procedure TForm1.PrintDialog1Click(Sender: TObject);
var
  Line:integer;
  PrintText:System.Text;
  ColorFont: TColor;
begin
  if PrintDialog1.Execute then
  begin
    AssignPrn(PrintText);
    Rewrite(PrintText);
    ColorFont:=Memo1.Font.Color;
    Memo1.Font.Color:=clBlack;
    Printer.Canvas.Font:=Memo1.Font;
    for line:=0 to 5 do writeln(PrintText);   //top margen 25.5.2001
    for line:=0 to Memo1.Lines.Count-1 do
      writeln(PrintText,'         ',Memo1.Lines[Line]);
    System.Close(PrintText);
    Memo1.Font.Color:=ColorFont;
  end;
end;

function TForm1.CloseQuery: boolean; 
begin  Result:=true;  end;
  
procedure TForm1.Cerrar(Sender: TObject);
begin
  Close;  
  Cerrada:=True;
  Abierta:=False;
end;

procedure InitMemos;
begin
  Application.CreateForm(TForm1,Form1);
  Form1.Caption:=Application.Title + ' Standard Output';
  Application.CreateForm(TForm1,Form2);
  Form2.Caption:=Application.Title + ' Trace Output';
  Application.CreateForm(TForm1,Form3);
  Form2.Top:=Form2.Top - 40;
  Form3.Caption:=Application.Title + ' Report Output';
  Form1.Abierta:=False;
  Form2.Abierta:=False;
  Form3.Abierta:=False;
  Form3.Width:=600;
  Form3.Top:=Form3.Top - 60;
end;

procedure VerArchivoSalida(var NomArchivo: string);
var F: file;
begin
  if not Form1.Abierta then
  begin
    Form1.Show;
    Form1.Cerrada:=False;
    Form1.NombreArchivo:=NomArchivo;
  end;
  try
  Form1.Memo1.Lines.LoadFromFile(NomArchivo);
  except on EInvalidOperation do begin
  MessageDlg('Output file too large. Save and use WordPad to see it',
             mtWarning,[mbOK],0);
  AssignFile(F,'$CON1');
  if Form1.SaveDialog1.Execute then
  begin
    Form1.NombreArchivo:=Form1.SaveDialog1.FileName;
    if FileExists(Form1.SaveDialog1.FileName) then
         if MessageDlg('File exists, overwite it ?',
             mtConfirmation,[mbYES,mbNO],0)=mrYES then
          begin
             DeleteFile(Form1.SaveDialog1.FileName);
             Rename(F,Form1.SaveDialog1.FileName);
          end
         else
     else Rename(F,Form1.SaveDialog1.FileName);
  end;
  end;
  end;
  Form1.Abierta:=False;
  Continua;
  {repeat
    Application.ProcessMessages
  until Form1.Cerrada or Form1.Abierta; }
end;

procedure VerArchivoTrazado(var NomArchivo: string);
var F: file;
begin
  if not Form2.Abierta then
  begin
    Form2.Show;
    Form2.Cerrada:=False;
    Form2.NombreArchivo:=NomArchivo;
  end;
 try
  Form2.Memo1.Lines.LoadFromFile(NomArchivo);
 except on EInvalidOperation do begin
  MessageDlg('Trace file too large. Save and use WordPad to see it',
             mtWarning,[mbOK],0);
  AssignFile(F,'$CON2');
  if Form2.SaveDialog1.Execute then
  begin
    Form2.NombreArchivo:=Form2.SaveDialog1.FileName;
    if FileExists(Form2.SaveDialog1.FileName) then
         if MessageDlg('File exists, overwite it ?',
             mtConfirmation,[mbYES,mbNO],0)=mrYES then
          begin
             DeleteFile(Form2.SaveDialog1.FileName);
             Rename(F,Form2.SaveDialog1.FileName);
          end
         else
     else Rename(F,Form2.SaveDialog1.FileName);
    Assign(_ftra,'$CON2'); Rewrite(_ftra);
  end;
  end;
 end;
  Form2.Abierta:=False;
  Form2.VertScrollBar.Range:=Form2.Memo1.Lines.Count;
  Form2.VertScrollBar.Position:=Form2.Memo1.Lines.Count;
  (*no funciona Form2.Memo1.SelStart:=Form2.Memo1.GetTextLen-1; {barra !!}
  Form2.Memo1.Repaint;  Application.ProcessMessages;*)
  Continua;
  {repeat
    Application.ProcessMessages
  until Form2.Cerrada or Form2.Abierta;}
end;

procedure VerArchivoReporte(var NomArchivo: string);
var F: file;
begin
  if not Form3.Abierta then
  begin
    Form3.Show;
    Form3.Cerrada:=False;
    Form3.NombreArchivo:=NomArchivo;
  end;
  try
  Form3.Memo1.Lines.LoadFromFile(NomArchivo);
  except on EInvalidOperation do begin
  MessageDlg('Report file too large. Save and use WordPad to see it',
             mtWarning,[mbOK],0);
  AssignFile(F,'$CON3');
  if Form3.SaveDialog1.Execute then
  begin
    Form3.NombreArchivo:=Form3.SaveDialog1.FileName;
    if FileExists(Form3.SaveDialog1.FileName) then
         if MessageDlg('File exists, overwite it ?',
             mtConfirmation,[mbYES,mbNO],0)=mrYES then
          begin
             DeleteFile(Form3.SaveDialog1.FileName);
             Rename(F,Form3.SaveDialog1.FileName);
          end
         else
     else Rename(F,Form3.SaveDialog1.FileName);
  end;
  end;
  end;
  Form3.Abierta:=False;
  Continua;
  {repeat
    Application.ProcessMessages
  until Form3.Cerrada or Form3.Abierta; }
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action:=caFree;
end;

end.
