unit Upresen;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, ExtCtrls, UPresen2, WDGraph, Gpmenus;

type
  TfPresen1 = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Button1: TButton;
    Image1: TImage;
    Reloj: TLabel;
    SimTime: TEdit;
    Mensajes: TEdit;
    Label4: TLabel;
    Repli: TEdit;
    Interrumpir: TButton;

    procedure FinPresenta(Sender: TObject);
    procedure Interrumpe(Sender: TObject);
   { procedure Cancelar(Sender: TObject; var Action: TCloseAction); }
    procedure FormCanResize(Sender: TObject; var NewWidth,
      NewHeight: Integer; var Resize: Boolean);
    procedure Cancelar(Sender: TObject; var Action: TCloseAction);
    procedure Button1KeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  fPresen1: TfPresen1;
  Termina, Interrumpible, Trazando: boolean;
  CharEstado: Char;
  PrimeraVezO:boolean;

  procedure Comienza;
  procedure Presenta; export;
  procedure Continua; export;
  procedure UnMensaje(Mensa: string); export;
  procedure AvanzaReloj(t: real; repli: integer); export;
  procedure MensajeOK;
  procedure ModoInterrupcion(SioNo: boolean); export;
  function  OKPressed(var _u: char; _bt: boolean): boolean; export;


implementation
uses Ggraphic, UGlMemo;
{$R *.DFM}

procedure MensajeOK;
begin
  repeat Application.ProcessMessages  until Termina;
  Termina:=false;
end;

procedure Continua;
begin
  fPresen1.Mensajes.Text:='Continue';
  MensajeOK;
end;

procedure UnMensaje(Mensa: string);
begin
  fPresen1.Mensajes.Text:=Mensa;
  MensajeOK;
end;

procedure Comienza;
begin
  Application.CreateForm(TfPresen1,FPresen1);
  Application.CreateForm(TFPresen2,FPresen2);
  Application.CreateForm(TFGgraphic,FGgraphic);
  fPresen1.Caption:=Application.Title;
  fPresen1.Visible:=True;  FPresen1.Enabled:=True;
  Termina:=false; Interrumpible:=False; Trazando:=False;
  CharEstado:=' ';PrimeraVezO:=true;
end;

procedure TfPresen1.FinPresenta(Sender: TObject);
begin
  Termina:=True;
  {Form1.Close;}
end;

procedure Presenta;
begin
  Comienza;
  repeat Application.ProcessMessages  until Termina;
  Termina:=False;
  FPresen1.SimTime.Text:='0.0';
  {FPresen1.Width:=740; 569 }
end;

procedure ModoInterrupcion(SioNo: boolean);
begin
  Interrumpible:=SioNo;
  If Interrumpible then FPresen1.Interrumpir.Enabled:=True
                   else FPresen1.Interrumpir.Enabled:=False;
  Application.ProcessMessages;
end;

procedure AvanzaReloj(t: real; repli: integer);
var linea: string[15];
begin
  Application.ProcessMessages;
  Str(t:16:2,linea);
  FPresen1.SimTime.Text:=linea;
  Str(repli:10,linea);
  FPresen1.Repli.Text:=linea;
end;

function  OKPressed(var _u: char; _bt: boolean): boolean;
begin
  Application.ProcessMessages;
  _u:=CharEstado;
  if _u = ' ' then OKPressed:=False
  else
  begin
    OKPressed:=True;
    CharEstado:=' ';
    if _bt and (_u='U') then _u:='T';
  end;
end;

procedure TfPresen1.Interrumpe(Sender: TObject);
begin
    FPresen2.BotonSel:=' ';
    FPresen2.Show;
    FPresen2.ActivaTrace.Enabled:=not Trazando;
    FPresen2.SuspendTrace.Enabled:=Trazando;
    repeat Application.ProcessMessages until FPresen2.BotonSel<>' ';
    CharEstado:=FPresen2.BotonSel;
    if CharEstado='T' then Trazando:=True
    else if CharEstado='U' then Trazando:=False;
    FPresen2.ActivaTrace.Enabled:=not Trazando;
    FPresen2.SuspendTrace.Enabled:=Trazando;
    FPresen2.Hide;
end;

{procedure TfPresen1.Cancelar(Sender: TObject; var Action: TCloseAction);
begin
   Action:=caNone
end;}

procedure TfPresen1.FormCanResize(Sender: TObject; var NewWidth,
  NewHeight: Integer; var Resize: Boolean);
begin
  Resize:=false;
end;

procedure TfPresen1.Cancelar(Sender: TObject; var Action: TCloseAction);
begin
  CloseGraph;
  Form1.Close;  Form2.Close;  Form3.Close;
  FGgraphic.Close;
  GMenus.Close;  
  Halt;
end;

procedure TfPresen1.Button1KeyPress(Sender: TObject; var Key: Char);
begin
  FinPresenta(Sender);
end;

end.
