unit Wdgraph;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Menus, ExtDlgs{, JPEG, ClipBrd};

const MAXVentanas = 150;
type
  prRefresher = procedure of object;   {6.03.2001}
  LineSettingsType = record
                      LineStyle: TPenStyle;
                      Pattern, Thickness: integer;
                    end;

  ViewPortType = record X1, Y1, X2, Y2: integer; Clip: boolean; end;
  TJustX = (LeftText, CenterText, RightText);
  TJustY = (TopText, BottonText);
  TFontsP= (ArialFont, RomanFont, CourierFont, TimesFont);
  TDirections = (HorizDir, VertDir);
  TFontsS = (verySmallFont, SmallFont, NormalFont, LargeFont, HugeFont);

  MouseActions = (ButtonDown, ButtonUp, Movement);
  ArrowAction = (LeftArrow, UpArrow, RightArrow, DownArrow);
  EventTypes = (NoneEvent, EventMouse, EventKey, EventArrow, EventVisibility);

  EventStructure = record
                     EventType: EventTypes;
                     x, y: integer;
                     WhichB: TMouseButton;
                     TypeMouseAction: MouseActions;
                     EstadoShift: TShiftState;
                     WhichArrow: ArrowAction;
                     WhichKey: Char;
                   end;

  TGrafico = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Save1: TMenuItem;
    SavePictureDialog1: TSavePictureDialog;
    procedure TeclaEx(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure TeclaChar(Sender: TObject; var Key: Char);
    procedure ArraSelec(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FinArrastre(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Refresh(Sender: TObject);
    procedure GuardaGrafico(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    {procedure FormResize(Sender: TObject);}
    {procedure FormCanResize(Sender: TObject; var NewWidth,
      NewHeight: Integer; var Resize: Boolean);  }


  private
    { Private declarations }

  public
    { Public declarations }
    theVP: ViewPortType;
    WhereX, WhereY: integer;
    JustX: TJustX;
    JustY: TJustY;
    DirVerticalText: boolean;
    {2000} NeedToRefresh, Abriendo, AbriendoResize: boolean;
    MouseEvent, KeyEvent, ArrowEvent, Dragging: boolean;
    CharExte: word;  CharChar: char;
    DataEvent: EventStructure;
    Refresher: prRefresher;  {6.03.2001}
  end;

var
  Grafico: TGrafico;
  aGrafico: array[1..MAXVentanas] of TGrafico;
  EntroFlecha: ArrowAction;
  nVentanas, sVentana: byte;


{multg 301.11.2000 procedure InitGraph(w,h: integer; Titulo: string); export; }
function  InitGraph(w,h: integer; Titulo: string): byte; export;
procedure SelectWindow(g: byte); export;
function  InitWindow(w,h: integer; Titulo: string): byte; export;
procedure Bar(x1, y1, x2, y2: integer); export;
procedure ClearDevice; export;
procedure Circle(x,y,r: integer); export;
procedure SetBkColor(col: Tcolor);export;
procedure SetColor(col: Tcolor); export;
procedure GFloodFill(sxi,syi: integer; MaxColor: TColor); export;
function  GetMaxY: integer; export;
function  GetMaxX: integer; export;
function  GetColor: TColor; export;
function  GetMaxColor: Tcolor; export;
function  GetPixel(x,y:integer): TColor; export;
procedure GetLineSettings(var LineInfo: LineSettingsType); export;
procedure GetViewSettings(var ViewPort: ViewPortType); export;
procedure SetLineStyle(Style: TPenStyle; nouse, width: integer);
          export;
procedure SetTextStyle(aFont: TFontsP; TextDirec: TDirections; aSize: TFontsS);
          export;
procedure Line(x1,y1,x2,y2: integer); export;
procedure OutTextXY(x,y: integer; const Texto: string); export;
procedure Rectangle(x1,y1,x2,y2: integer); export;
procedure RotateText(x,y: integer; const Texto: string); export;
procedure OutText(const Texto: string); export;
procedure MoveRel(dx,dy: integer); export;
procedure MoveTo(x,y: integer); export;
procedure SetFillStyle(Pattern: TBrushStyle; ColorF: TColor); export;
procedure SetTextJustify(jx: TJustX; jy: TJustY); export;
procedure SetViewPort(x1,y1,x2,y2: integer; Clip: boolean); export;
procedure PutPixel(x,y: longint; col: Tcolor); export;
function  TextHeight(const T: string): integer; export;
function  TextWidth(const T: string): integer; export;
procedure LineRel(dx,dy: integer); export;
procedure LineTo(x,y: integer); export;
procedure CloseWindow; export;
procedure CloseGraph; export;
procedure NextEvent(var theEvent: EventStructure); export;

implementation

{$R *.DFM}

procedure SelectWindow(g: byte);
begin
  {multg 30.11.2000 if g=1 then Grafico:=aGrafico[1]
         else Grafico:=aGrafico[2]; 2001}
  if g in [1..MAXVentanas] then Grafico:=aGrafico[g];
  {Grafico.Show;}
  sVentana:=g;
  Application.ProcessMessages;
end;

{multg 30.11.2000 procedure InitGraph(w,h: integer; Titulo: string); }
function InitGraph(w,h: integer; Titulo: string): byte;
{var v: byte;}
begin
  {multg 30.11.2000 nVentanas:=0;}
  InitGraph:=InitWindow(w,h,Titulo);
end;

function InitWindow(w,h: integer; Titulo: string): byte;
var i, sumaW, sumaH: integer;
begin
  if nVentanas = MAXVentanas then
  begin InitWindow:=0; MessageDlg('Maximum number of Graphic Windows exceeded',
                                   mtError,[mbOK],0); end
  else
  {2001 if nVentanas = 255 then InitWindow:=0 else}
  begin
  Inc(nVentanas);
  Application.CreateForm(TGrafico, aGrafico[nVentanas]);
 {2000 if nVentanas=2 then aGrafico[2].Position:=poScreenCenter;}
 if nventanas > 1 then
 begin
  {2001 tile}
  sumaH:=0; sumaW:=0;
  i:=nVentanas -1;
  repeat
  {sumaW:=(aGrafico[nVentanas-1].Left+aGrafico[nVentanas-1].Width);
  sumaH:=(aGrafico[nVentanas-1].Top+aGrafico[nVentanas-1].height); }
   sumaW:=sumaW+aGrafico[i].Width;
   Dec(i);
  until (i=0) or (aGrafico[i].Left >= aGrafico[i+1].Left);
  i:=nVentanas -1;
  repeat
    sumaH:=sumaH+aGrafico[i].height;
    Dec(i);
  until (i=0) or (aGrafico[i].Top >= aGrafico[i+1].Top);
  if Screen.width-sumaw > w {500} then
  begin aGrafico[nVentanas].Left:=sumaW;
        aGrafico[nVentanas].Top:=aGrafico[nVentanas-1].Top; end
  else
  begin
    aGrafico[nVentanas].Left:=aGrafico[1].Left;
    if Screen.height-sumaH > h {200} then
       aGrafico[nVentanas].Top:=sumaH + 50 {-350 }
    else
       aGrafico[nVentanas].Top:=aGrafico[nVentanas-1].Top + 50;
  end;
  {aGrafico[nVentanas-1].Visible:=false;}
 end else
 begin
  aGrafico[nVentanas].Left:=1;
  aGrafico[nVentanas].Top:=50
 end;
  Grafico:=aGrafico[nVentanas];
  Grafico.NeedToRefresh:=false;
  Grafico.Abriendo:=true;   Grafico.AbriendoResize:=true;
  Grafico.Height:=h;
  Grafico.Width:=w;
  Grafico.Caption:=Titulo;
  Grafico.Visible:=true;
  Grafico.WhereX:=1;        Grafico.WhereY:=1;
  Grafico.JustX:=LeftText;  Grafico.JustY:=TopText;
  Grafico.DirVerticalText:=false;
  Grafico.Canvas.Font.Name:='Arial';
  Grafico.Canvas.Font.Size:=8;
  Grafico.Canvas.Brush.Style:=bsClear;
  with Grafico.theVP do
  begin X1:=0; Y1:=0; X2:=GetMaxX; Y2:=GetMaxY; Clip:=false; end;
  Grafico.KeyEvent:=false;
  Grafico.MouseEvent:=false;
  Grafico.ArrowEvent:=false;
  Grafico.DataEvent.EventType:=NoneEvent;
  ClearDevice;
  sVentana:=nVentanas; 
  InitWindow:=nVentanas;
  Application.ProcessMessages;
  end;
end;

procedure Bar(x1, y1, x2, y2: integer);
begin with Grafico do
  Canvas.Rectangle(x1+theVP.X1,y1+theVP.Y1,
                   x2+theVP.X1,y2+theVP.Y1);
  Application.ProcessMessages;
end;

procedure Circle(x,y,r: integer);
var xf, yf: integer;
begin  x:=x + Grafico.theVP.X1;  y:=y + Grafico.theVP.Y1;
  xf:=x + r;  yf:= y + r;
  x:= x - r;  y:=  y -r;
  Grafico.Canvas.Arc(x,y,xf,yf,x,y,x,y);
  Application.ProcessMessages;
end;

procedure ClearDevice;
begin  Grafico.Canvas.FillRect(Grafico.ClientRect);
       Application.ProcessMessages;
end;

procedure SetBkColor(col: Tcolor);
begin Grafico.Color:=col;
      Grafico.Canvas.Brush.Color:=col;
end;

procedure SetColor(col: Tcolor);
begin     Grafico.Canvas.Pen.Color:=col;
          Grafico.Canvas.Font.Color:=col;
end;

procedure GFloodFill(sxi,syi: integer; MaxColor: TColor);
begin with Grafico do
           Canvas.FloodFill(sxi+theVP.X1,syi+theVP.Y1,MaxColor,fsBorder);
           Application.ProcessMessages;
end;

function GetMaxY: integer;
begin    {GetMaxY:=Grafico.Top + Grafico.Height;}
          GetMaxY:=Grafico.ClientRect.Bottom;  end;

function GetMaxX: integer;
begin    {GetMaxX:=Grafico.Left + Grafico.Width;}
         GetMaxX:=Grafico.ClientRect.Right;  end;

function GetColor: TColor;
begin
  GetColor:=Grafico.Canvas.Pen.Color;
end;

function GetMaxColor: TColor;
begin    GetMaxColor:= {clBlack; }{d }Grafico.Canvas.Pen.Color;  end;

function  GetPixel(x,y:integer): TColor;
begin  with Grafico do
  GetPixel:=Canvas.Pixels[longint(x+theVP.X1), longint(y+theVP.Y1)]; end;

procedure GetLineSettings(var LineInfo: LineSettingsType);
begin
  LineInfo.LineStyle:=Grafico.Canvas.Pen.Style;
  LineInfo.Thickness:=Grafico.Canvas.Pen.Width;
end;

procedure GetViewSettings(var ViewPort: ViewPortType);
begin
  ViewPort:=Grafico.theVP;
end;

procedure SetLineStyle(Style: TPenStyle; nouse, width: integer);
begin     Grafico.Canvas.Pen.Style:=Style;
          Grafico.Canvas.Pen.Width:= width;
end;

procedure Line(x1,y1,x2,y2: integer);
begin  with Grafico do begin
          Canvas.MoveTo(x1+theVP.X1,y1+theVP.Y1);
          WhereX:=x2+theVP.X1;
          WhereY:=y2+theVP.Y1;
          Canvas.LineTo(WhereX,WhereY);
          Application.ProcessMessages;
       end;
end;

procedure LineRel(dx,dy: integer);
begin
  with Grafico do begin
       Canvas.LineTo(WhereX+dx,WhereY+dy);
       WhereX:=WhereX+dx;  WhereY:=WhereY+dy;
       Application.ProcessMessages;
  end;
end;

procedure OutTextXY(x,y: integer; const Texto: string);
begin  with Grafico do
 begin
  case Ord(JustX) of
  1:   {CenterText}
         x:= x - Canvas.TextWidth(Texto) div 2;
  2:   {RightText}
         x:= x - Canvas.TextWidth(Texto);
  end;
  if JustY = BottonText then
         y:= y - Canvas.TextHeight(Texto);

  Canvas.TextOut(x+theVP.X1,y+theVP.Y1,Texto);
  If DirVerticalText then RotateText(x+theVP.X1,y+theVP.Y1,Texto);
 end;
 Application.ProcessMessages;
end;

procedure Rectangle(x1,y1,x2,y2: integer);
begin with Grafico do begin
    Canvas.MoveTo(x1+theVP.X1,y1+theVP.Y1);
    Canvas.LineTo(x2+theVP.X1,y1+theVP.Y1);
    Canvas.LineTo(x2+theVP.X1,y2+theVP.Y1);
    Canvas.LineTo(x1+theVP.X1,y2+theVP.Y1);
    Canvas.LineTo(x1+theVP.X1,y1+theVP.y1);
end;
Application.ProcessMessages;
end;

procedure RotateText(x,y: integer; const Texto: string);
var i, j: Longint; punto: TColor;
begin
With Grafico.Canvas do begin
  for i:=0 to TextWidth(Texto) do
   for j:=0 to TextHeight(Texto) do
    begin
      punto:=Pixels[x+i,y+j];
      Pixels[x+i,y+j]:=Grafico.Color; {borra}
      Pixels[x+j,y-i]:=punto;
    end;
end;
end;

procedure MoveRel(dx,dy: integer);
begin with Grafico do begin
           WhereX:=WhereX+dx;  WhereY:=WhereY+dy;
           Canvas.MoveTo(WhereX,WhereY);
      end;
      Application.ProcessMessages;
end;

procedure MoveTo(x,y: integer);
begin with Grafico do begin
          WhereX:=x+theVP.X1;  WhereY:=y+theVP.Y1;
          Canvas.MoveTo(WhereX,WhereY);
      end;
      Application.ProcessMessages;
end;

procedure SetTextJustify(jx: TJustX; jy: TJustY);
begin     Grafico.JustX:=jx; Grafico.JustY:=jy;  end;

procedure SetFillStyle(Pattern: TBrushStyle; ColorF: TColor);
begin
  with Grafico.Canvas.Brush do begin Style:=Pattern; Color:=ColorF; end;
end;

procedure SetTextStyle(aFont: TFontsP; TextDirec: TDirections; aSize: TFontsS);
begin
  case aFont of
  ArialFont:  Grafico.Canvas.Font.Name:='Arial';
  RomanFont:  Grafico.Canvas.Font.Name:='Roman';
  CourierFont:Grafico.Canvas.Font.Name:='Courier';
  TimesFont:  Grafico.Canvas.Font.Name:='Times';
  end;
  Grafico.DirVerticalText:= TextDirec = VertDir;
  case aSize of
  verySmallFont: Grafico.Canvas.Font.Size:=6;
      SmallFont: Grafico.Canvas.Font.Size:=8;
     NormalFont: Grafico.Canvas.Font.Size:=10;
      LargeFont: Grafico.Canvas.Font.Size:=12;
       HugeFont: Grafico.Canvas.Font.Size:=16;
  end;
end;

procedure OutText(const Texto: string);
var x, y: integer;
begin  with Grafico do
 begin
  x:=WhereX;  y:=WhereY;
  case Ord(JustX) of
  1:   {CenterText}
         x:= x - Canvas.TextWidth(Texto) div 2;
  2:   {RightText}
         x:= x - Canvas.TextWidth(Texto);
  end;
  if JustY = BottonText then
         y:= y - Canvas.TextHeight(Texto);

  Canvas.TextOut(x,y,Texto);
  WhereX:=WhereX + Canvas.TextWidth(Texto);
 end;
 Application.ProcessMessages;
end;

procedure PutPixel(x,y: longint; col: Tcolor);
begin with Grafico do Canvas.Pixels[x+theVP.X1,y+theVP.Y1]:=col;
      Application.ProcessMessages;
end;

function  TextHeight(const T: string): integer;
begin     TextHeight:=Grafico.Canvas.TextHeight(T); end;

function  TextWidth(const T: string): integer;
begin     TextWidth:=Grafico.Canvas.TextWidth(T); end;

procedure LineTo(x,y: integer);
begin with Grafico do begin
           Canvas.LineTo(x+theVP.X1,y+theVP.Y1);
           WhereX:=x+theVP.X1;  WhereY:=y+theVP.Y1;
      end;
      Application.ProcessMessages;
end;

procedure SetViewPort(x1,y1,x2,y2: integer; Clip: boolean);
begin
  with Grafico do begin
       theVP.X1:=x1; theVP.Y1:=y1; theVP.X2:=x2;
       theVP.Y2:=y2; theVP.Clip:=Clip;
  end;
end;

procedure CloseWindow;
begin     Grafico.Close;
{multg 2001}  Grafico.Free;  Dec(nVentanas);
          Application.ProcessMessages;
end;

procedure CloseGraph;
var v, nV: byte;
begin
  nV:=nVentanas;
  for v:=1 to nV do begin SelectWindow(v); CloseWindow; end;
end;

procedure NextEvent(var theEvent: EventStructure);
begin
  theEvent:=Grafico.DataEvent;
  Grafico.DataEvent.EventType:=NoneEvent;
  Application.ProcessMessages;
end;

procedure TGrafico.TeclaEx(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (not KeyEvent) and (not ArrowEvent) then
  begin
     CharExte:=Key;
     If (CharExte > 36) and (CharExte < 41) then
     begin
       ArrowEvent:=true;
       case CharExte of
       37:  EntroFlecha:=LeftArrow;
       38:  EntroFlecha:=UpArrow;
       39:  EntroFlecha:=RightArrow;
       40:  EntroFlecha:=DownArrow;
       end;
     end;
     DataEvent.EventType:=EventArrow;
     DataEvent.WhichArrow:=EntroFlecha;
  end;
  Application.ProcessMessages;
end;

procedure TGrafico.TeclaChar(Sender: TObject; var Key: Char);
begin
  if (not KeyEvent) and (not ArrowEvent) then
  begin
    KeyEvent:=true; CharChar:=Key;
    DataEvent.EventType:=EventKey;
    DataEvent.WhichKey:=CharChar;
  end
  else
  begin
    KeyEvent:=False; ArrowEvent:=False;
  end;
end;

procedure TGrafico.ArraSelec(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  If not MouseEvent then begin
     MouseEvent:=true;   {Queda bloqueado hasta que se recoja el evento}
     with DataEvent do begin
          EventType:=EventMouse;
          TypeMouseAction:=ButtonDown;
          WhichB:=Button;
          EstadoShift:=Shift;
     end;
     DataEvent.x:= X{-ClientOrigin.x};
     DataEvent.y:= Y{-ClientOrigin.y};
  end;
  Application.ProcessMessages;
end;

procedure TGrafico.FinArrastre(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
   If {not} MouseEvent then begin
     MouseEvent:={true} false;   {Desbloquea y recoja el evento}
     with DataEvent do begin
          TypeMouseAction:=ButtonUp;
          WhichB:=Button;
          EstadoShift:=Shift;
     end;
     DataEvent.x:= X{-ClientOrigin.x};
     DataEvent.y:= Y{-ClientOrigin.y};
  end;
  Application.ProcessMessages;
end;

{multg 30.11.2000}
procedure TGrafico.Refresh(Sender: TObject);
begin
  if Abriendo then Abriendo:=false
  else if not NeedToRefresh then begin {NeedToRefresh:=True;} {6.3.2001}
              if Assigned(Refresher) then Refresher; end;
end;

procedure TGrafico.GuardaGrafico(Sender: TObject);
var elGrafico: {TJPEGImage;}  TBitMap;
    // elClipB: TClipBoard;
begin
  // elGrafico:=TJPEGImage.Create; // TBitMap.Create;
  elGrafico:=TBitMap.Create;
  elGrafico.Width:=ClientWidth;
  elGrafico.Height:=ClientHeight;
  elGrafico.Canvas.CopyRect(Grafico.ClientRect,
                            Grafico.Canvas,Grafico.ClientRect);
  //elClipB:=ClipBoard;
  //elClipB.Assign(Grafico.Canvas); // 2.5.2001
  //elGrafico.Assign(elClipB);
  //elGrafico.Assign(Grafico.GetFormImage);   //Canvas
//  elGrafico.Compress;
  //SavePictureDialog1.DefaultExt := GraphicExtension(TJPEGImage); //TBitmap);
  //SavePictureDialog1.Filter := GraphicFilter(TJPEGImage); //TBitmap);
  SavePictureDialog1.DefaultExt := GraphicExtension(TBitmap);
  SavePictureDialog1.Filter := GraphicFilter(TBitmap);

  {elGrafico.Canvas.Draw(0,0,Grafico.GetFormImage);}
  {elGrafico:=GetFormImage;}
  if SavePictureDialog1.Execute then  begin
     elGrafico.SaveToFile(SavePictureDialog1.FileName);
     elGrafico.Free; end;
end;

procedure TGrafico.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action:=caNone
end;

(*procedure TGrafico.FormResize(Sender: TObject);
begin
  if not AbriendoResize then {AbriendoResize:=false
  else} NeedToRefresh:=true;
end;*)

{procedure TGrafico.FormCanResize(Sender: TObject; var NewWidth,
  NewHeight: Integer; var Resize: Boolean);
begin
   ShowMessage(IntToStr(NewWidth)+' '+IntToStr(NewHeight));
   Resize:=false;
end;  }

initialization

nVentanas:=0;

end.
