unit UWGlider;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Menus, Printers, ClipBrd, Search, ComCtrls;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    Model: TMenuItem;
    Select1: TMenuItem;
    Compile1: TMenuItem;
    Run1: TMenuItem;
    Exit1: TMenuItem;
    Memo1: TMemo;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    Save1: TMenuItem;
    SaveAs1: TMenuItem;
    Options1: TMenuItem;
    ConsoleApplication1: TMenuItem;
    CompleteCompilation1: TMenuItem;
    PartialCompilation1: TMenuItem;
    New1: TMenuItem;
    PrintSetup1: TMenuItem;
    Print1: TMenuItem;
    Edit1: TMenuItem;
    Cut1: TMenuItem;
    Copy1: TMenuItem;
    Paste1: TMenuItem;
    Delete1: TMenuItem;
    SelectAll1: TMenuItem;
    Search1: TMenuItem;
    Find1: TMenuItem;
    Replace1: TMenuItem;
    N1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    SearchAgain1: TMenuItem;
    PrintDialog1: TPrintDialog;
    FindDialog1: TFindDialog;
    ReplaceDialog1: TReplaceDialog;
    PrinterSetupDialog1: TPrinterSetupDialog;
    StatusBar1: TStatusBar;
    GoLine1: TMenuItem;
    procedure ModelSelect(Sender: TObject);
    procedure Compilar(Sender: TObject);
    procedure Ejecutar(Sender: TObject);
    procedure Terminar(Sender: TObject);
    procedure TomarDir(Sender: TObject);
    procedure SaveAs1Click(Sender: TObject);
    procedure Save1Click(Sender: TObject);
    procedure ChangeConsole(Sender: TObject);
    procedure ChangeCompile(Sender: TObject);
    procedure NuevoFile(Sender: TObject);
    procedure Cut1Click(Sender: TObject);
    procedure Copy1Click(Sender: TObject);
    procedure Delete1Click(Sender: TObject);
    procedure Paste1Click(Sender: TObject);
    procedure Print1Click(Sender: TObject);
    procedure PrintSetup1Click(Sender: TObject);
    procedure UpdateMenus;
    procedure Edit1Click(Sender: TObject);
    procedure Find1Click(Sender: TObject);
    procedure Replace1Click(Sender: TObject);
    procedure FindDialog1Find(Sender: TObject);
    procedure ReplaceDialog1Replace(Sender: TObject);
    procedure SearchAgain1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure SelectAll1Click(Sender: TObject);
    procedure Memo1Change(Sender: TObject);
    procedure Memo1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Memo1KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure unCambio(Sender: TObject);
    procedure GoLine1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }

  end;

var
  Form1: TForm1;
  ProgName, ModelName, DPRName, ExecName, DirName, DirModel: string;
  CompiladoOK, Excedido, Nuevo: boolean;
  pExecName: PChar;
  BatComando: string;
  pBatComando: PChar;
  i: integer;
  Testigo: file;
  NumLine, NumCol, SumaLines, HuboAlt: integer;

implementation

{$R *.DFM}

procedure TForm1.ModelSelect(Sender: TObject);
begin
  if Memo1.Modified then
     if
     MessageDlg('File has changed. Save it ?',mtConfirmation,[mbYes,mbNo],0)
     =mrYes then begin Save1Click(Sender); Memo1.Modified:=false; end;

  if OpenDialog1.Execute then
  begin
        Memo1.Lines.Clear; Memo1.Invalidate; Excedido:=false; Nuevo:=false;
        ProgName:=OpenDialog1.FileName;
        {Tomar nombre Directorio de Trabajo}
        i:=Length(ProgName);
        while (i > 0) and (ProgName[i] <> '\') do i:=i - 1;
            DirModel:=Copy(ProgName,1,i);
        try
          Memo1.Lines.LoadFromFile(ProgName);
          NumLine:=1; NumCol:=1;
          StatusBar1.SimpleText:='Line 1'{+IntToStr(Memo1.SelStart+1)}+
                                 ' Col 1' ;
        except on EInvalidOperation do
                  begin
                    Excedido:=true;
                    MessageDlg(
'File too large. You can compile it, but use WordPad to see or modify',
                               mtWarning,[mbOK],0);
                  end;
        end;
        ModelName:=Copy(ProgName,1,Length(ProgName)-3);
        ExecName:=ModelName+'exe'#0; {null char}
        DPRName:=Copy(ModelName,1,Length(ModelName)-1);
  {ShowMessage(ProgName);
  ShowMessage(ModelName);
  ShowMessage(ModelName[1]);}
        pExecName:=@ExecName[1];
        CompiladoOk:=False;
  end;
end;

procedure TForm1.Compilar(Sender: TObject);
var F: file;
begin
  if ModelName='' then
  begin
   if Nuevo then SaveAs1Click(Sender)
   else Exit;
  end
  else if Memo1.Modified then
     if
     MessageDlg('File has changed. Save it ?',mtConfirmation,[mbYes,mbNo],0)
     =mrYes then begin Save1Click(Sender); Memo1.Modified:=false; end;
  {BatComando:=DirName+'DWGL.BAT '+ ModelName+' '+DirName+#0;}
  {Para poder chequear fin de compilacion}
  if FileExists('Testigo.GGG') then
  begin AssignFile(F,'Testigo.GGG'); Erase(F); end;
  if FileExists(ModelName+'exe') then
  begin AssignFile(F,ModelName+'exe'); Erase(F); end;
  if FileExists(ModelName+'dpr') then
  begin AssignFile(F,ModelName+'dpr'); Erase(F); end;
  {Precompilador}
  BatComando:=DirName+'DUG8.EXE '+ ProgName+#0;
{ShowMessage(BatComando);}
  pBatComando:=@BatComando[1];
  WinExec(pBatComando,SW_SHOWNORMAL);
  {Chequear si no hubo errores de sintaxis}
  repeat until FileExists('Testigo.GGG');

  if CompleteCompilation1.Checked then
  if FileExists(ModelName+'dpr') then
  begin
    repeat until (FileExists('pru.pas')) and (FileExists('unid1.pas'));
    {BatComando:=DirName+'DWGL.BAT '+ ModelName+#0;}
    {Compilador Delphi}
    if ConsoleApplication1.Checked then
    {BatComando:='DCC32 -u'+DirName+' -B -M -CC '+ ModelName+'DPR'+#0}
    {BatComando:='DCC32 -u'+DirName+' -M -CC '+ ModelName+'DPR'+#0}
//Delphi6 28.1.2002 BatComando:=DirName+'DWGLp.BAT '+ DPRName+' '+DirName+#0
     BatComando:=DirName+'DWGLp.BAT '+ DPRName+' '+DirName+' '+ DirModel+#0
    else
    {BatComando:='DCC32 -u'+DirName+' -M '+ ModelName+'DPR'+#0;}
    //Delphi6 28.1.2002 BatComando:=DirName+'DWGL.BAT '+ DPRName+' '+DirName+#0;
     BatComando:=DirName+'DWGL.BAT '+ DPRName+' '+DirName+' '+ DirModel+#0;
    pBatComando:=@BatComando[1];
{ShowMessage(BatComando); }
    WinExec(pBatComando,SW_SHOWNORMAL);
    {Borre archivos intermedios}
    {BatComando:=DirName+'DWGL.BAT '+DirName+#0;
    pBatComando:=@BatComando[1];
    repeat until FileExists(ModelName+'exe');}
    repeat until not FileExists('Testigo.GGG');
    if not FileExists(ModelName+'exe') then
       MessageDlg('DELPHI Pascal Syntax Error: Use DELPHI',mtError,[mbOK],0);
    {WinExec(pBatComando,SW_SHOWNORMAL);}
  end
  else begin
         Erase(Testigo);
         MessageDlg('GLIDER Syntax Error',mtError,[mbOK],0);
       end
  else begin
         Erase(Testigo);
       end;
end;

procedure TForm1.Ejecutar(Sender: TObject);
begin
  if ModelName<>'' then
     WinExec(pExecName,SW_SHOWNORMAL);
end;

procedure TForm1.Terminar(Sender: TObject);
begin
  if Memo1.Modified then
     if
     MessageDlg('File has changed. Save it ?',mtConfirmation,[mbYes,mbNo],0)
     =mrYes then Save1Click(Sender);
  {Close;}
  Application.Terminate;
end;

procedure TForm1.TomarDir(Sender: TObject);
var i: integer;
begin
  Memo1.MaxLength:=0;
  DirName:=ParamStr(0);
  i:=Length(DirName);
  while (i > 0) and (DirName[i] <> '\') do i:=i - 1;
  DirName:=Copy(DirName,1,i);
{ShowMessage(Dirname);}
  AssignFile(Testigo,'Testigo.GGG');
end;

procedure TForm1.SaveAs1Click(Sender: TObject);
begin
if SaveDialog1.Execute then
  begin
    ProgName:=SaveDialog1.FileName;
    if ProgName[length(ProgName)-3]<>'.' then
       ProgName:=ProgName+'.gld';
    Memo1.Lines.SaveToFile(ProgName);
    ModelName:=Copy(ProgName,1,Length(ProgName)-3);
    ExecName:=ModelName+'exe'#0; {null char}
    pExecName:=@ExecName[1];
    CompiladoOk:=False; Nuevo:=false; Excedido:=false;
  end;
end;

procedure TForm1.Save1Click(Sender: TObject);
begin
  if ModelName<>'' then
    if not Excedido then
            Memo1.Lines.SaveToFile(ProgName)
    else MessageDlg('File too large, it was not loaded',mtWarning,[mbOK],0)
  else SaveAs1Click(Sender);
end;

procedure TForm1.ChangeConsole(Sender: TObject);
begin
  ConsoleApplication1.Checked:=not ConsoleApplication1.Checked;
end;

procedure TForm1.ChangeCompile(Sender: TObject);
begin
  if CompleteCompilation1.Checked then
  begin CompleteCompilation1.Checked:=false;
        PartialCompilation1.Checked:=true;
  end else
  begin CompleteCompilation1.Checked:=true;
        PartialCompilation1.Checked:=false;
  end;
end;

procedure TForm1.NuevoFile(Sender: TObject);
begin
  Memo1.Lines.Clear;
  ModelName:='';
  Nuevo:=true;
  CompiladoOk:=False; Excedido:=false;
  StatusBar1.SimpleText:=''; NumLine:=1; NumCol:=1; HuboAlt:=0;
end;

procedure TForm1.Cut1Click(Sender: TObject);
begin
  Memo1.CutToClipboard;
end;

procedure TForm1.Copy1Click(Sender: TObject);
begin
   Memo1.CopyToClipboard;
end;

procedure TForm1.Delete1Click(Sender: TObject);
begin
  Memo1.ClearSelection;
end;

procedure TForm1.Paste1Click(Sender: TObject);
begin
  Memo1.PasteFromClipboard;
end;

procedure TForm1.Print1Click(Sender: TObject);
var
  Line:integer;
  PrintText:System.Text;
  ColorFont: TColor;
begin
  if PrintDialog1.Execute then
  begin
    AssignPrn(PrintText);
    Rewrite(PrintText);
    ColorFont:=Memo1.Font.Color;
    Memo1.Font.Color:=clBlack;
    Printer.Canvas.Font:=Memo1.Font;
    for line:=0 to 5 do writeln(PrintText);   //top margen 25.5.2001
    for line:=0 to Memo1.lines.count-1 do
      writeln(PrintText,'         ',Memo1.Lines[line]);
    System.Close(PrintText);
    Memo1.Font.Color:=ColorFont;
  end;
end;

procedure TForm1.PrintSetup1Click(Sender: TObject);
begin
  PrinterSetupDialog1.Execute;
end;

procedure TForm1.UpdateMenus;
var
  Seleccion:Boolean;
begin
  Paste1.Enabled:=Clipboard.HasFormat(CF_TEXT);
  Seleccion:=Memo1.SelLength <> 0;
  Cut1.Enabled:=Seleccion;
  Copy1.Enabled:=Seleccion;
  Delete1.Enabled:=Seleccion;
end;

procedure TForm1.Edit1Click(Sender: TObject);
begin
  UpdateMenus;
end;

procedure TForm1.Find1Click(Sender: TObject);
begin
  FindDialog1.Execute;
  SearchAgain1.Enabled:=True;
end;

procedure TForm1.Replace1Click(Sender: TObject);
begin
  ReplaceDialog1.Execute;
end;

procedure TForm1.FindDialog1Find(Sender: TObject);
begin
  with Sender as TFindDialog do
    if not SearchMemo(Memo1, FindText,options) then
      ShowMessage('Cannot find "'+FindText+'".');
end;

procedure TForm1.ReplaceDialog1Replace(Sender: TObject);
var
  found:Boolean;
begin
  with ReplaceDialog1 do
  begin
    if AnsiCompareText(Memo1.SelText,FindText) = 0 then
      Memo1.SelText:=ReplaceText;
    found:=SearchMemo(Memo1,FindText,Options);
    while found and (frReplaceAll in Options) do
    begin
      Memo1.SelText:=ReplaceText;
      found:=SearchMemo(Memo1,FindText,Options);
    end;
    if (not found) and (frReplace in Options) then
      ShowMessage('Cannot find "'+FindText+'".');
  end;
end;

procedure TForm1.SearchAgain1Click(Sender: TObject);
begin
  FindDialog1Find(FindDialog1);
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if Memo1.Modified then
     if
     MessageDlg('File has changed. Save it ?',mtConfirmation,[mbYes,mbNo],0)
     =mrYes then Save1Click(Sender);
  Action:=caFree;
end;

procedure TForm1.SelectAll1Click(Sender: TObject);
begin
  Memo1.SelectAll;
end;

procedure TForm1.Memo1Change(Sender: TObject);
begin
  NumLine:=0;  SumaLines:=0;
  while SumaLines+length(Memo1.Lines[NumLine])+2<Memo1.SelStart do begin
        SumaLines:=SumaLines+length(Memo1.Lines[NumLine])+2;
        Inc(NumLine); {ShowMessage(IntToStr(SumaLines));}
  end;
  Inc(NumLine);
  {ShowMessage(IntToStr(SumaLines)+' SelStart '+IntToStr(Memo1.SelStart));}
  NumCol:=Memo1.SelStart - SumaLines + 1;
  StatusBar1.SimpleText:='Line '+IntToStr(NumLine)+
                         ' Col '+IntToStr(NumCol);
end;

procedure TForm1.Memo1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if ssAlt in Shift then Inc(HuboAlt)else
  BEGIN
  if HuboAlt>0 then begin if HuboAlt>1 then Inc(NumCol); HuboAlt:=0; end;
  case key of
  13: begin Inc(NumLine); NumCol:=1; end;
  16,17: ;
//  18: {Alt} Inc(HuboAlt);
   8: begin {<-}
        if length(Memo1.Lines[NumLine-1])>0 then Dec(NumCol)
        else if NumLine > 1 then
          begin Dec(NumLine); NumCol:=length(Memo1.Lines[NumLine-1])+1; end;
      end;
   37:  {FlechaIzq} if NumCol>1 then Dec(NumCol);
   38:  {FlechaUp}  if NumLine>1 then
                        begin Dec(NumLine);
                          if NumCol>length(Memo1.Lines[NumLine-1])
                          then NumCol:=length(Memo1.Lines[NumLine-1]);
                          if NumCol=0 then NumCol:=1;
                        end;
   39:  {FlechaDer} if NumCol<=length(Memo1.Lines[NumLine-1])
                        then Inc(NumCol)
                        else begin Inc(NumLine); NumCol:=1; end;
   40:  {FlechaAba} if NumLine<Memo1.Lines.Count then
                        begin Inc(NumLine);
                          if NumCol>length(Memo1.Lines[NumLine-1])
                          then NumCol:=length(Memo1.Lines[NumLine-1]);
                          if NumCol=0 then NumCol:=1;
                        end;
    46: {key=46 Supress}
    else Inc(NumCol); {inserta caracter}
    end;
    StatusBar1.SimpleText:='Line '+IntToStr(NumLine)+
                           ' Col '+IntToStr(NumCol){+' '+IntToStr(Key)};
    {if ssShift in Shift then StatusBar1.SimpleText:=StatusBar1.SimpleText+
       ' SHIFT'; }
    END;
end;

procedure TForm1.Memo1KeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if HuboAlt>0 then
     if not (ssAlt in Shift) then
        begin if HuboAlt>1 then
          begin Inc(NumCol);
            StatusBar1.SimpleText:='Line '+IntToStr(NumLine)+
                           ' Col '+IntToStr(NumCol){+' '+IntToStr(Key)};
          end;
          HuboAlt:=0;
        end;
end;

procedure TForm1.unCambio(Sender: TObject);
begin
  StatusBar1.SimpleText:=StatusBar1.SimpleText+' OnChange';
end;

procedure TForm1.GoLine1Click(Sender: TObject);
var sNumLinea: string; i, iNumLinea: integer; WChar: longint;
begin
   sNumLinea:='';
   sNumLinea:=InputBox('Go Line','Enter Line Number:',sNumLinea);
   if sNumLinea<>'' then
   begin 
     try
        iNumLinea:=StrToInt(sNumlinea);
        with Memo1 do
          if (iNumLinea>0) and (iNumLinea <= Lines.Count) then
          begin
           if iNumLinea<>NumLine then
            begin
            if iNumLinea > NumLine then
             begin  //flecha abajo
                   iNumLinea:=iNumLinea - NumLine;  WChar:=40; end
             else
             begin  //flecha arriba
                   iNumLinea:=NumLine - iNumLinea;  WChar:=38; end;
             for i:=1 to iNumLinea do
               Perform(WM_KEYDOWN,WChar,0);
               // Application.ProcessMessages;
            end;
          end
          else MessageDlg('Line number 0 or exceeds file size',mtError,[mbOK],0);
      except on EInOutError do
               MessageDlg('Invalid line number',mtError,[mbOK],0);
      end;
   end;
end;

initialization

  ModelName:='';
  CompiladoOk:=False; Excedido:=false; Nuevo:=false;
  NumLine:=1; NumCol:=1; HuboAlt:=0;
end.
