unit Search;
{Tomado del ejemplo TEXTDEMO, suministrado por Delhpi 1.0}
interface
uses WinProcs, SysUtils, StdCtrls, Dialogs;
const
  {Son Delimitadores de palabras cualquier caracter, excepto los cdigos
  alfanumricos}
  WordDelimiters: set of Char = [#0..#255] - ['a'..'z','A'..'Z','1'..'9','0'];
{ SearchMemo revisa el texto de controles como TEdit, TMemo, o cualquier
  componente derivado de la clase TCustomEdit, en busca de una cadena de texto
  La bsqueda comienza desde la posicin actual del puntero en el control.
  Los parmetros (Options) determinan si la bsqueda es hecha Hacia Adelante
  (frDown) o Hacia Atrs de la posicin del puntero, si la comparacin
  es sensible al Uso de Maysculas o no, y si la cadena buscada debe
  corresponderse con una palabra completa. Si la cadena es encontrada,
  el texto hallado es seleccionado (resaltado) y la funcin retorna TRUE,
  de lo contrario retornar FALSE.  }
function SearchMemo(Memo: TCustomEdit;
                    const SearchString: String;
                    Options: TFindOptions): Boolean;
{ SearchBuf es una rutina de bsqueda de bajo nivel para cualquier buffer
  de texto. Sigue las mismas reglas de la funcin SearchMemo. Si la cadena
  es encontrada, la funcin retorna un puntero al inicio de la cadena
  dentro del buffer. Si no es encontrada, retorna NIL }
function SearchBuf(Buf: PChar; BufLen: Integer;
                   SelStart, SelLength: Integer;
                   SearchString: String;
                   Options: TFindOptions): PChar;
implementation
function SearchMemo(Memo: TCustomEdit;
                    const SearchString: String;
                    Options: TFindOptions): Boolean;
var
  Buffer, P: PChar;
  Size: Word;
begin
  Result := False;
  if (Length(SearchString) = 0) then Exit;
  Size := Memo.GetTextLen;
  if (Size = 0) then Exit;
  Buffer := StrAlloc(Size + 1);
  try
    Memo.GetTextBuf(Buffer, Size + 1);
    P := SearchBuf(Buffer, Size, Memo.SelStart, Memo.SelLength,
                   SearchString, Options);
    if P <> nil then
    begin
      Memo.SelStart := P - Buffer;
      Memo.SelLength := Length(SearchString);
      Result := True;
    end;
  finally
    StrDispose(Buffer);
  end;
end;
function SearchBuf(Buf: PChar; BufLen: Integer;
                   SelStart, SelLength: Integer;
                   SearchString: String;
                   Options: TFindOptions): PChar;
var
  SearchCount, I: Integer;
  C: Char;
  Direction: Shortint;
  CharMap: array [Char] of Char;
  function FindNextWordStart(var BufPtr: PChar): Boolean;
  begin                   { (True XOR N) es equivalente a (not N) }
    Result := False;      { (False XOR N) es equivalent a (N)    }
{ Si la Bsqueda es Hacia Adelante (1), salte los no Delimitadores, luego los delimitadores. }
{ Si l Bsqueda es Hacia Atrs (-1), salte delimitadores, luego los no delimitadores }
    while (SearchCount > 0) and
          ((Direction = 1) xor (BufPtr^ in WordDelimiters)) do
    begin
      Inc(BufPtr, Direction);
      Dec(SearchCount);
    end;
    while (SearchCount > 0) and
          ((Direction = -1) xor (BufPtr^ in WordDelimiters)) do
    begin
      Inc(BufPtr, Direction);
      Dec(SearchCount);
    end;
    Result := SearchCount >= 0;
    if (Direction = -1) and (BufPtr^ in WordDelimiters) then
    begin   { retroceda un caracter, para asignar al puntero el primer No Delimitador }
      Dec(BufPtr, Direction);
      Inc(SearchCount);
    end;
  end;
begin
  Result := nil;
  if BufLen <= 0 then Exit;
  if frDown in Options then
  begin
    Direction := 1;
    Inc(SelStart, SelLength);
    SearchCount := BufLen - SelStart - Length(SearchString);
{    SearchCount := BufLen - SelStart - Length(SearchString) + 1;}
    if SearchCount < 0 then Exit;
    if Longint(SelStart) + SearchCount > BufLen then Exit;
  end
  else
  begin
    Direction := -1;
    Dec(SelStart, Length(SearchString));
    SearchCount := SelStart;
{    SearchCount := SelStart + 1;}
  end;
  if (SelStart < 0) or (SelStart > BufLen) then Exit;
  Result := @Buf[SelStart];
  { Usar un arreglo de caracteres es ms rpido que llamar la funcin AnsiUpper
    en cada caracter }
  for C := Low(CharMap) to High(CharMap) do
    CharMap[C] := C;
  if not (frMatchCase in Options) then
  begin
    AnsiUpperBuff(PChar(@CharMap), sizeof(CharMap));
    AnsiUpperBuff(@SearchString[1], Length(SearchString));
  end;
  while SearchCount >= 0 do
  begin
    if frWholeWord in Options then
      if not FindNextWordStart(Result) then Break;
    I := 0;
    while (CharMap[Result[I]] = SearchString[I+1]) do
    begin
      Inc(I);
     if I >= Length(SearchString) then
      begin
        if (not (frWholeWord in Options)) or
           (SearchCount = 0) or
           (Result[I] in WordDelimiters) then
          Exit;
        Break;
      end;
    end;
    Inc(Result, Direction);
    Dec(SearchCount);
  end;
  Result := nil;
end;
end.
